import java.awt.Frame;
import java.awt.image.BufferedImage;
import javax.imageio.ImageIO;
import java.io.File;
import java.io.RandomAccessFile;
import java.nio.ByteBuffer;
import java.nio.channels.FileChannel;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;

public class Viewer {

	public static void main(String[] args) throws Exception {
		System.loadLibrary("java-img");

		final Frame f = new Frame("Viewer");

		BufferedImage bi;
		File file = new File(args[1]);

		if(args[0].equals("i")) {
			bi = ImageIO.read(file);
		} else {
			ByteBuffer bb = ByteBuffer.allocateDirect((int) file.length());
			FileChannel c = new RandomAccessFile(file, "r").getChannel();

			long sum = bb.capacity();
			while(sum > 0) {
				sum -= c.read(bb);
			}

			c.close();

			bi = getImage(bb);
		}

		f.add(new ImageCanvas(bi));

		f.setSize(bi.getWidth(), bi.getHeight());

		f.setVisible(true);

		f.addWindowListener(new WindowAdapter() {
			public void windowClosing(WindowEvent we) {
				f.dispose();
			}
		});

	}

	private static native BufferedImage getImage(ByteBuffer buffer);

}
